package app04c.form;

import app04c.util.DateTool;
import java.text.ParseException;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import javax.servlet.http.HttpServletRequest;
import java.util.Date;

public final class OrderForm extends ActionForm {
  
  private int productId;
  private String customer;
  private int quantity;
  private String quantityAsString;
  private Date orderDate;
  private String orderDateAsString;
  private float price;
  private String priceAsString;
  
  public String getOrderDateAsString() {
		return orderDateAsString;
  }
	public void setOrderDateAsString(String orderDateAsString) {
  	this.orderDateAsString = orderDateAsString;
  }
  public String getPriceAsString() {
  	return priceAsString;
  }
  public void setPriceAsString(String priceAsString) {
  	this.priceAsString = priceAsString;
  }  
  public String getQuantityAsString() {
  	return quantityAsString;
  }
  public void setQuantityAsString(String quantityAsString) {
		this.quantityAsString = quantityAsString;
  }


  public int getProductId() {
    return productId;
  }
  public void setProductId(int productId) {
    this.productId = productId;
  }
  public String getCustomer() {
    return customer;
  }
  public void setCustomer(String customer) {
    this.customer = customer;
  }
  public Date getOrderDate() {
    return orderDate;
  }
  public void setOrderDate(Date orderDate) {
    this.orderDate = orderDate;
  }
  public int getQuantity() {
    return quantity;
  }
  public void setQuantity(int quantity) {
    this.quantity = quantity;
  }
  public float getPrice() {
     return price;
  }
  public void setPrice(float price) {
  	this.price = price;
  }

  public void reset(ActionMapping mapping, HttpServletRequest request) {
    orderDateAsString = DateTool.format(new Date());  
  }
  
  public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
    ActionErrors errors = new ActionErrors();

    //Validate Customer
    if (customer.trim().equals("")) {
      errors.add("order", new ActionMessage("missing.customer"));
    }

    //Validate Quantity
    if (quantityAsString.trim().equals("")) {
      errors.add("order", new ActionMessage("missing.quantity"));
    }
    else {
      try {
        quantity = Integer.parseInt(quantityAsString);
      }
      catch (NumberFormatException e) {
        errors.add("order", new ActionMessage("invalid.quantity"));
      }
    }

    //Validate Price
    if (priceAsString.trim().equals("")) {
      errors.add("price", new ActionMessage("missing.price"));
    }
    else {
      try {
        price = Float.parseFloat(priceAsString);
      }
      catch (NumberFormatException e) {
        errors.add("price", new ActionMessage("invalid.price"));
      }
    }

    //Validate OrderDate
    if (orderDateAsString.trim().equals("")) {
      errors.add("order", new ActionMessage("missing.orderDate"));
    }
    else {
      try {
        orderDate = DateTool.parse(orderDateAsString);
        DateTool.format(orderDate);
      }
      catch (ParseException e) {
        errors.add("order", new ActionMessage("invalid.orderDate"));
      }
    }
    
    return errors;
  }
}
